package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.params.DHParameters;
import cn.com.infosec.crypto.params.DHValidationParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class DHParametersGenerator {
   private static final BigInteger TWO = BigInteger.valueOf(2L);
   private int size;
   private int certainty;
   private SecureRandom random;

   public void init(int size, int certainty, SecureRandom random) {
      this.size = size;
      this.certainty = certainty;
      this.random = random;
   }

   public DHParameters generateParameters() {
      int var1 = this.certainty;
      BigInteger var2;
      BigInteger[] var4;
      BigInteger var10000 = var2 = (var4 = DHParametersHelper.generateSafePrimes(this.size, var1, this.random))[0];
      DHParametersGenerator var10001 = this;
      BigInteger var3 = var4[1];
      BigInteger var5 = DHParametersHelper.selectGenerator(var10000, var3, var10001.random);
      BigInteger var10002 = var2;
      var2 = TWO;
      return new DHParameters(var10002, var5, var3, var2, (DHValidationParameters)null);
   }
}
